<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title></title>
<link rel="shortcut icon" href="{{ url_for('static', filename='css/images/5028-512.png') }}" />

<script src="{{ url_for('static', filename='js/vendor/jquery-3.2.1/jquery-3.2.1.min.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/jquery-ui-1.12.1/jquery-ui.min.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/jstorage/jstorage.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/json2/json2.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/jquery-sortable/Sortable.min.js') }}"></script>
<script src="{{ url_for('static', filename='js/vendor/jquery-sortable/jquery-sortable.js') }}"></script>

<script src="{{ url_for('static', filename='js/class.base-3.15.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.bootstrap-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.gui-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.inline_templates-3.13.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.scratchpad-3.13.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.services-3.15.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.stored-queries-3.15.js') }}"></script>
<script src="{{ url_for('static', filename='js/class.query-maintenance-3.15.js') }}"></script>

<script src="{{ url_for('static', filename='js/ns.bind-keys-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/ns.config-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/ns.functions-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/ns.main-3.17.js') }}"></script>
<script src="{{ url_for('static', filename='js/ns.maintenance-3.15.js') }}"></script>

<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/inline_templates.css') }}" />
<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/jquery-ui.css') }}" />
<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/style-3.17.css') }}" />
<link rel="stylesheet" type="text/css" media="screen" title="default" href="{{ url_for('static', filename='css/maintenance-3.15.css') }}" />

<script>
$(document).ready(function(e)
{

	/*
		globals
		jQuery (incl. $.jStorage)
		jsonPath

		var config (config.js)
		var functions (functions.js)
		var bindKeys (bind-keys.js)
		var main (main.js) for convenience
	*/

	main.onLoad();

	scratchpad = new Scratchpad(config,{
		name: "Query scratchpad for the Netherlands Biodoversity API",
		version: "2.x", // current version is retrieved from version history table
		date: "2017", 	// current date retrieved from version history table
		author: "Maarten Schermer",
		email: "maarten.schermer@naturalis.nl",
	});

	scratchpad.setServer({
		url: window.location.protocol + "//{{ nba_address }}",
		proxyUrl: window.location.protocol + "//" + window.location.host,
		proxyPath: "{{ url_for('proxy_request') }}",
		urlTestPath: "{{ url_for('url_test_request') }}",
		nbaServer: window.location.protocol + "//{{ nba_address }}",
		nbaVersion: "{{ nba_version }}",
		private_nba_address: "{{ private_nba_address }}",
		public_nba_address: "{{ nba_address }}"
	});

	templates = new Templates();
	gui = new GUI(config,scratchpad.getServer());
	query_maintenance = new QueryMaintenance(config);

	services = new Services(config,scratchpad.getServer());
	services.setDefaultRestServiceLists(config.defaultServiceList);
	services.setServices();
	services.addStaticServices();

	if (!$.jStorage.storageAvailable())
	{
		alert("No local storage available.\nYou can write and execute queries, but cannot save them.");
	}
	else
	{
		stored_queries = new StoredQueries(config,scratchpad.getServer());

		stored_queries.setTemplates([
			{ label: "queryTpl", code: templates.fetchTemplate("maintenance_queryTpl") },
			{ label: "groupTpl", code: templates.fetchTemplate("maintenance_groupTpl") },
			{ label: "useQuerySymbolAndServiceTpl", code: templates.fetchTemplate("useQuerySymbolAndServiceTpl") },
			{ label: "useQuerySymbolTpl", code: templates.fetchTemplate("useQuerySymbolTpl") },
			{ label: "noteSymbolTpl", code: templates.fetchTemplate("noteSymbolTpl") },
			{ label: "emptyNoteSymbolTpl", code: templates.fetchTemplate("emptyNoteSymbolTpl") },
			{ label: "importErrorTpl", code: templates.fetchTemplate("importErrorTpl") },
			{ label: "importOptionsTpl", code: templates.fetchTemplate("importOptionsTpl") },
		]);

		stored_queries.cleanUp();
		stored_queries.setQueries();
		stored_queries.setQueries();
		stored_queries.printList();

		query_maintenance.setStoredQueries(stored_queries.getQueries());
		query_maintenance.bootstrap();
		query_maintenance.setTemplates([
			{ label: "queryExampleTpl", code: templates.fetchTemplate("queryExampleTpl") },
		]);
	}

	window.onbeforeunload = function()
	{
		if (query_maintenance.getHasTreeChanged())
		{
			return "you have unsaved changes.\nare you sure you want to leave?";
		}
	};

});
</script>
</head>

<body>

<div class="main">

	<h3>
		Stored query maintenance
	</h3>

	<a href="{{ scratchpad_path }}" target="_top">back to scratchpad</a><br/>

	<p>
		Please note: this page hasn't been exhaustively tested, so before you begin, it might be wise to do a
		<span
			class="setting link"
			title="click to export all saved queries to download folder"
			onclick="stored_queries.quickExport();">quick export of all queries</span>,
			which will write a file with all queries to your Downloads-folder.
	</p>

	<p>
		You can drag and drop queries in the list below to change the order in which they are displayed. Once you are done reordering,
		click 'save new query order' to store.
	</p>
	<p>
		Queries can be moved to and from groups, but groups can not be moved into groups. You can drop them there, but
		the result will not be saved. Moving the last query from a group will automatically remove the group when you save.
	</p>
	<p>
		Adding a new group:
		<input type="input" id="new_group" placeholder="new group name" style="font-size:11px;">
		<input type="button" value="add group" onclick="query_maintenance.makeNewGroup();maintenance.refreshQueryTree();">
	</p>
	<p>
		Please note: if you add a new group, an empty query called '(placeholder)' is created within it, for technical reasons. These placeholders will be deleted  when you save the new order of your queries. If, at time of saving, you haven't moved any queries into the new group, the group will be deleted as well.
	</p>

	<div>

		<p>
			<input type="button" value="save new query order" onclick="maintenance.saveNewQueryOrder();">
			<span id="message"></span>
		</p>

		<div id="query-list" class="query-list">
			<span>saved queries:</span>
			<ul id="queries" class="queries query-list-item list-group col nested-sortable" data-drag="top">
			</ul>
		</div>


	</div>
</div>


<div id="dialog" title=""><p class="content"></p></div>

{% include 'templates.html' %}

</body>
</html>